// SaltUSBIOMini.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "SaltUSBIOMini.h"

#include <stdlib.h>
#include <tchar.h>
#include "..\..\avrusb-20081126\examples\hid-data\firmware\USB-IO-Mini.h"

#define USBIOMINI_VENDOR_ID  (0x16C0)
#define USBIOMINI_PRODUCT_ID (0x05DF)
#define USBIOMINI_VENDOR_NAME  _T("CQB01600@nifty.com")
#define USBIOMINI_PRODUCT_NAME _T("USB-IO-Mini")



/* TvȂ̂ō폜

// This is an example of an exported variable
SALTUSBIOMINI_API int nSaltUSBIOMini=0;

// This is an example of an exported function.
SALTUSBIOMINI_API int fnSaltUSBIOMini(void)
{
	return 42;
}

*/

// This is the constructor of a class that has been exported.
// see SaltUSBIOMini.h for the class definition
CSaltUSBIOMini::CSaltUSBIOMini()
{
	m_hUSBIO = NULL;

	return;
}

CSaltUSBIOMini::~CSaltUSBIOMini()
{
	Uninitialize();
}

BOOL CSaltUSBIOMini::Initialize(unsigned char ucDeviceID)
{
	TRACE0(_T("CSaltUSBIOMini::Initialize()\n"));

	Uninitialize();		// ɃI[vĂAUN[Y

	GUID guidHID;
	::HidD_GetHidGuid(&guidHID);	
	TRACE1(_T("guidGuid = %08X\n"), guidHID);

	// SetupDiGetClassDevs returns a device information set that contains all devices of a specified class.
	HANDLE hDevInfo = ::SetupDiGetClassDevs(
							&guidHID,
							NULL,
							NULL,
							DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	TRACE1(_T("hDevInfo = %08X\n"), hDevInfo);	

	m_hUSBIO = NULL;
	int nIndex = 0;
	while (!m_hUSBIO) {
		SP_DEVICE_INTERFACE_DATA spdeviceinterfacedata;
		spdeviceinterfacedata.cbSize = sizeof(spdeviceinterfacedata);

		// SetupDiEnumDeviceInterfaces returns a con_T structure for a device interface element of a device information set.
		// Each call returns information about one device interface; the function can be called repeatedly to get information about several interfaces exposed by one or more devices.
		BOOLEAN bResult = ::SetupDiEnumDeviceInterfaces(
								hDevInfo,
								0,
								&guidHID,
								nIndex,
								&spdeviceinterfacedata);
		TRACE1(_T("bResult = %d\n"), bResult);

		if (bResult) {	// 񂪎ꂽAڍ׃f[^擾

			// ܂ATCY炤
			DWORD dwLength;
			bResult = ::SetupDiGetDeviceInterfaceDetail(
						hDevInfo,
						&spdeviceinterfacedata,
						NULL,				//  0 Ȃ NULL
						0,					// 0 ȂTCY̎擾
						&dwLength,
						NULL);
			TRACE2(_T("bResult = %d, dwLength = %08X\n"), bResult, dwLength);

			// ēx call āAf[^炤
			PSP_DEVICE_INTERFACE_DETAIL_DATA pspdeviceinterfacedetaildata;
			pspdeviceinterfacedetaildata = (PSP_DEVICE_INTERFACE_DETAIL_DATA) malloc(dwLength);
			pspdeviceinterfacedetaildata->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
			bResult = ::SetupDiGetDeviceInterfaceDetail(
							hDevInfo,
							&spdeviceinterfacedata,
							pspdeviceinterfacedetaildata,
							dwLength,
							&dwLength,	//NULL,
							NULL);
			TRACE2(_T("bResult = %d, dwLength = %08X\n"), bResult, dwLength);

			// I[v
			TRACE1(_T("path = %s\n"), pspdeviceinterfacedetaildata->DevicePath);
			HANDLE hDevice = ::CreateFile(
							pspdeviceinterfacedetaildata->DevicePath,
							GENERIC_READ | GENERIC_WRITE,
							FILE_SHARE_READ | FILE_SHARE_WRITE,
							NULL,
							OPEN_EXISTING,
							0,
							NULL);
			TRACE1(_T("hDevice = %08X\n"), hDevice);
			if (hDevice  == INVALID_HANDLE_VALUE) {
				TRACE0(_T("CreateFile() failed.\n"));
				// continue;
			}


			HIDD_ATTRIBUTES hiddattributes;
			hiddattributes.Size = sizeof(hiddattributes);
			// t@Cnh瑮擾
			bResult = ::HidD_GetAttributes(hDevice, &hiddattributes);			
			TRACE1(_T("bResult = %d\n"), bResult);
			TRACE2(_T("VendorID = %08X, ProductID = %08X\n"), hiddattributes.VendorID, hiddattributes.ProductID);

			// Vendor ID, Product ID `FbN
			if (hiddattributes.VendorID == USBIOMINI_VENDOR_ID
					&& hiddattributes.ProductID == USBIOMINI_PRODUCT_ID) {
				TRACE0(_T("found AVR-USB products\n"));

				// Manufacture string  Product string `FbN
				TCHAR szBuf[0x80];
				if (HidD_GetManufacturerString(hDevice, szBuf, sizeof(szBuf))) {
					TRACE1(_T("vendorName = \"%s\"\n"), szBuf);
					if (_tcscmp(USBIOMINI_VENDOR_NAME, szBuf) == 0) {
						if (HidD_GetProductString(hDevice, szBuf, sizeof(szBuf))) {
							TRACE1(_T("productName = \"%s\"\n"), szBuf);
							if (_tcscmp(USBIOMINI_PRODUCT_NAME, szBuf) == 0) {

								TRACE0(_T("found USB-IO-Mini !\n"));
								m_hUSBIO = hDevice;
								GetCapabilities();

								if (ucDeviceID != 0xff) {
									//  ID ̂ݑΏۂƂ
									if (GetDeviceID() != ucDeviceID) {
										TRACE0(_T("but device id doesn't match !\n"));
										m_hUSBIO = NULL;
									}

								}

							}
						}
						else {
							TRACE0(_T("error obtaining product name\n"));
						}

					}
				}
				else {
					TRACE0(_T("error obtaining vendor name\n"));
				}

			}

			// foCXȂ΁Aclose Ă
			if (!m_hUSBIO)
				CloseHandle(hDevice);

			free(pspdeviceinterfacedetaildata);
		}
		else
			break;

		nIndex++;
	}
		
	::SetupDiDestroyDeviceInfoList(hDevInfo);


	#if _DEBUG
	if (!m_hUSBIO)
		TRACE0(_T("USB-IO-Mini doesn't find.\n"));
	#endif // _DEBUG

	return (BOOL) m_hUSBIO;

}

BOOL CSaltUSBIOMini::Uninitialize(void)
{
	TRACE0(_T("CSaltUSBIOMini::Uninitialize()\n"));

	if (m_hUSBIO) {
		::CloseHandle(m_hUSBIO);
		m_hUSBIO = NULL;
	}

	return TRUE;
}

BOOL CSaltUSBIOMini::GetCapabilities(void)
{
	PHIDP_PREPARSED_DATA phidppreparseddata;

	BOOL bResult = ::HidD_GetPreparsedData(m_hUSBIO, &phidppreparseddata);
	TRACE1(_T("bResult = %d\n"), bResult);

	HIDP_CAPS hidpcaps;
	bResult = ::HidP_GetCaps(phidppreparseddata, &hidpcaps);
	TRACE1(_T("bResult = %d\n"), bResult);
	if (bResult == HIDP_STATUS_SUCCESS) {
		TRACE0(_T("HIDP_STATUS_SUCCESS\n"));
	}
	else if (bResult == HIDP_STATUS_INVALID_PREPARSED_DATA) {
		TRACE0(_T("HIDP_STATUS_INVALID_PREPARSED_DATA\n"));
	}

	TRACE1(_T("Usage Page                     : %d\n"), hidpcaps.UsagePage);
	TRACE1(_T("Input Report Byte Length       : %d\n"), hidpcaps.InputReportByteLength);
	TRACE1(_T("Output Report Byte Length      : %d\n"), hidpcaps.OutputReportByteLength);
	TRACE1(_T("Feature Report Byte Length     : %d\n"), hidpcaps.FeatureReportByteLength);
	m_nFeatureReportByteLength = hidpcaps.FeatureReportByteLength;
	TRACE1(_T("Number of Link Collection Nodes: %d\n"), hidpcaps.NumberLinkCollectionNodes);
	TRACE1(_T("Number of Input Button Caps    : %d\n"), hidpcaps.NumberInputButtonCaps);
	TRACE1(_T("Number of InputValue Caps      : %d\n"), hidpcaps.NumberInputValueCaps);
	TRACE1(_T("Number of InputData Indices    : %d\n"), hidpcaps.NumberInputDataIndices);
	TRACE1(_T("Number of Output Button Caps   : %d\n"), hidpcaps.NumberOutputButtonCaps);
	TRACE1(_T("Number of Output Value Caps    : %d\n"), hidpcaps.NumberOutputValueCaps);
	TRACE1(_T("Number of Output Data Indices  : %d\n"), hidpcaps.NumberOutputDataIndices);
	TRACE1(_T("Number of Feature Button Caps  : %d\n"), hidpcaps.NumberFeatureButtonCaps);
	TRACE1(_T("Number of Feature Value Caps   : %d\n"), hidpcaps.NumberFeatureValueCaps);
	TRACE1(_T("Number of Feature Data Indices : %d\n"), hidpcaps.NumberFeatureDataIndices);

	::HidD_FreePreparsedData(phidppreparseddata);

	return bResult;
}

int CSaltUSBIOMini::GetDeviceID(void)
{
	if (!m_hUSBIO)
		return -1;

	unsigned char *pucBuf = new unsigned char [m_nFeatureReportByteLength];
	pucBuf[0] = 0x00;					//  0x00
	pucBuf[1] = UIMC_READ_DEVICE_ID;	// read command 
	WriteRAW(pucBuf);					// write ΁A

	ReadRAW(pucBuf);					//  read ɕԂĂ

	int nDeviceID = (int) pucBuf[2];

	delete [] pucBuf;

	return nDeviceID;
}


// pbData[0] ́A 0x00 ̕KvBreportNumber Ȃ̂ŁB
// GetFeatureReportByteLength() Ŏ擾TCỸobt@Kv
// pbData[1] ` pbData[GetFeatureReportByteLength() - 1] Ƀf[^ԂĂ
BOOL CSaltUSBIOMini::ReadRAW(BYTE *pbData)
{
	// TRACE0(_T("CSaltUSBIOMini::ReadRAW()\n"));


	if (!m_hUSBIO)
		return FALSE;

	BYTE bResult= HidD_GetFeature(m_hUSBIO, pbData, m_nFeatureReportByteLength);
	if (!bResult) {
		TRACE1(_T("HidD_GetFeature() failed. GetLastError() = %08X\n"), GetLastError());
	}
	//else {
	//	TRACE4(_T("HidD_GetFeature() succeeded. %02X, %02X, %02X, %02X\n"), pbData[0], pbData[1], pbData[2], pbData[3]);
	//}

	return bResult;
}

// pbData[0] ́A 0x00 ̕KvBreportNumber Ȃ̂ŁB
// GetFeatureReportByteLength() Ŏ擾TCỸobt@Kv
// pbData[1] ` pbData[GetFeatureReportByteLength() - 1] ̃f[^
BOOL CSaltUSBIOMini::WriteRAW(BYTE *pbData)
{
	// TRACE0(_T("CSaltUSBIOMini::WriteRAW()\n"));

	if (!m_hUSBIO)
		return FALSE;

	BOOL bResult = HidD_SetFeature(m_hUSBIO, pbData, m_nFeatureReportByteLength);
	if (!bResult) {
		TRACE1(_T("HidD_SetFeature() failed. GetLastError() = %08X\n"), GetLastError());
	}
	//else {
	//	TRACE4(_T("HidD_SetFeature() succeeded. %02X, %02X, %02X, %02X\n"), pbData[0], pbData[1], pbData[2], pbData[3]);
	//}

	return bResult;
}


unsigned char CSaltUSBIOMini::Read(unsigned char *pucResult)
{
	if (!m_hUSBIO) {
		if (!Initialize()) {
			if (pucResult)
				*pucResult = FALSE;
			return FALSE;
		}
	}

	unsigned char *pucBuf = new unsigned char [m_nFeatureReportByteLength];

	pucBuf[0] = 0x00;					//  0x00
	BOOL bResult = ReadRAW(pucBuf);		// pucBuf[1]  mode = UIMC_SET_READ_MODE_D4A0`D1A3 ԂĂ
										// pucBuf[2]  PB5, PB4, PB3, PB0 ̒lԂĂ
	unsigned char ucResult = pucBuf[2];

	delete [] pucBuf;

	if (pucResult) {
		*pucResult = bResult;
	}

	return ucResult;
}

BOOL CSaltUSBIOMini::Write(unsigned char ucData, unsigned char ucMask)
{
	if (!m_hUSBIO)
		if (!Initialize())
			return FALSE;

	unsigned char *pucBuf = new unsigned char [m_nFeatureReportByteLength];

	pucBuf[0] = 0x00;					//  0x00
	pucBuf[1] = UIMC_WRITE_DATA;		// command
	pucBuf[2] = ucData;					// data
	pucBuf[3] = ucMask;					// mask
	BOOL bResult = WriteRAW(pucBuf);

	delete [] pucBuf;

	return bResult;
}

BOOL CSaltUSBIOMini::SetDirection(unsigned char ucData)
{
	if (!m_hUSBIO)
		if (!Initialize())
			return FALSE;

	unsigned char *pucBuf = new unsigned char [m_nFeatureReportByteLength];

	pucBuf[0] = 0x00;					//  0x00
	pucBuf[1] = UIMC_SET_DIRECTION;		// command
	pucBuf[2] = ucData;					// data
	BOOL bResult = WriteRAW(pucBuf);

	delete [] pucBuf;

	return bResult;
}