// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the SALTUSBIOMINI_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// SALTUSBIOMINI_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef SALTUSBIOMINI_EXPORTS
#define SALTUSBIOMINI_API __declspec(dllexport)
#else
#define SALTUSBIOMINI_API __declspec(dllimport)
#endif


extern "C" {
#include "..\FromDDK\setupapi.h"		// needs setupapi.lib in FromDDK <http://www.intel.com/intelpress/usb/examples/ZipFiles/FromDDK.htm>
#include "..\FromDDK\hidsdi.h"			// needs hid.lib in FromDDK <http://www.intel.com/intelpress/usb/examples/ZipFiles/FromDDK.htm>
}

// for debug
#if defined(_DEBUG)
	#if !defined(TRACE)	// afx.h œo^ĂΕKvȂ
	#include <stdio.h>
	#include <stdlib.h>
	#include <tchar.h>
	#define TRACE_STR_SIZE 0x200
	#define TRACE0(strText) ::OutputDebugString(strText);
	#define TRACE1(strFormat, param)                         { TCHAR sszzBBuuff[TRACE_STR_SIZE]; _stprintf_s(sszzBBuuff, TRACE_STR_SIZE, strFormat, param);                         ::OutputDebugString(sszzBBuuff); };
	#define TRACE2(strFormat, param, param2)                 { TCHAR sszzBBuuff[TRACE_STR_SIZE]; _stprintf_s(sszzBBuuff, TRACE_STR_SIZE, strFormat, param, param2);                 ::OutputDebugString(sszzBBuuff); };
	#define TRACE3(strFormat, param, param2, param3)         { TCHAR sszzBBuuff[TRACE_STR_SIZE]; _stprintf_s(sszzBBuuff, TRACE_STR_SIZE, strFormat, param, param2, param3);         ::OutputDebugString(sszzBBuuff); };
	#define TRACE4(strFormat, param, param2, param3, param4) { TCHAR sszzBBuuff[TRACE_STR_SIZE]; _stprintf_s(sszzBBuuff, TRACE_STR_SIZE, strFormat, param, param2, param3, param4); ::OutputDebugString(sszzBBuuff); };
	#endif // !defined(TRACE)
#else // _DEBUG
	#define TRACE0(str_T)
	#define TRACE1(strFormat, xx)
	#define TRACE2(strFormat, xx, yy)
	#define TRACE3(strFormat, xx, yy, zz)
	#define TRACE4(strFormat, xx, yy, zz, aa)
#endif // _DEBUG

// This class is exported from the SaltUSBIOMini.dll
class SALTUSBIOMINI_API CSaltUSBIOMini {
public:
	CSaltUSBIOMini(void);
	// TODO: add your methods here.

	virtual ~CSaltUSBIOMini();
	BOOL Initialize(unsigned char ucDeviceID = 0xFF);
	BOOL Uninitialize(void);
	int GetFeatureReportByteLength(void) { return m_nFeatureReportByteLength; };
	BOOL IsInitialized(void) { return (BOOL) m_hUSBIO; };

private:
	BOOL GetCapabilities(void);
	int GetDeviceID(void);

	HANDLE m_hUSBIO;
	int m_nFeatureReportByteLength;

public:

	// R}h܂ރf[^zǂݏ
	BOOL ReadRAW(BYTE *pbData);
	BOOL WriteRAW(BYTE *pbData);

	// R}hʂɃ\bhpӂĂ
	// Ńf[^zmۂ̂ŒxBƌĂAbԐ񂵂ANZXłȂɂ͑SeB
	unsigned char Read(unsigned char *pucResult = NULL);		// BOOL Read(unsigned char *pucData);
	BOOL Write(unsigned char ucData) { return Write(ucData, 0x0F); }
	BOOL Write(unsigned char ucData, unsigned char ucMask);		// ucMask  1 ̂Ƃ
	BOOL SetDirection(unsigned char ucData);

};

/* TvȂ̂ō폜

extern SALTUSBIOMINI_API int nSaltUSBIOMini;

SALTUSBIOMINI_API int fnSaltUSBIOMini(void);

*/