
// TestSaltUSBIOMiniDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestSaltUSBIOMini.h"
#include "TestSaltUSBIOMiniDlg.h"

#include <Windowsx.h>	// Button_GetCheck()
#include "..\..\avrusb-20081126\examples\hid-data\firmware\USB-IO-Mini.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestSaltUSBIOMiniDlg dialog




CTestSaltUSBIOMiniDlg::CTestSaltUSBIOMiniDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestSaltUSBIOMiniDlg::IDD, pParent)
	, m_nDeviceID(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestSaltUSBIOMiniDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_DEVICE_ID, m_nDeviceID);
	DDV_MinMaxInt(pDX, m_nDeviceID, 0, 255);
}

BEGIN_MESSAGE_MAP(CTestSaltUSBIOMiniDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_INITIALIZE, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonInitialize)
	ON_BN_CLICKED(IDC_BUTTON_UNINITIALIZE, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonUninitialize)
	ON_BN_CLICKED(IDC_BUTTON_READ_VERSION, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonReadVersion)
	ON_BN_CLICKED(IDC_BUTTON_READ_ID, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonReadId)
	ON_BN_CLICKED(IDC_BUTTON_WRITE_ID, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonWriteId)
	ON_BN_CLICKED(IDC_BUTTON_SET_READ_MODE, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonSetReadMode)
	ON_BN_CLICKED(IDC_BUTTON_SET_DIRECTION, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonSetDirection)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_READ, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonRead)
	ON_BN_CLICKED(IDC_BUTTON_WRITE1000, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonWrite1000)
	ON_BN_CLICKED(IDC_BUTTON_READ1000, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonRead1000)
	ON_BN_CLICKED(IDC_CHECK_AUTO_POLLING, &CTestSaltUSBIOMiniDlg::OnBnClickedCheckAutoPolling)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_RESET_FUSE_BITS, &CTestSaltUSBIOMiniDlg::OnBnClickedButtonResetFuseBits)
END_MESSAGE_MAP()


// CTestSaltUSBIOMiniDlg message handlers

BOOL CTestSaltUSBIOMiniDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestSaltUSBIOMiniDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestSaltUSBIOMiniDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestSaltUSBIOMiniDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestSaltUSBIOMiniDlg::OnBnClickedButtonInitialize()
{
	// TODO: Add your control notification handler code here
	if (m_usbiomini.Initialize()) {				// ŏɌ USB-IO-Mini g
	// if (m_usbiomini.Initialize(0x01)) {		// Device ID = 0x01  USB-IO-Mini Tꍇ
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_INITIALIZE)->GetSafeHwnd(), _T("succeeded"));

		Button_SetCheck(GetDlgItem(IDC_RADIO_D4A0)->GetSafeHwnd(), 1);		// WI{^̂PI
		Button_SetCheck(GetDlgItem(IDC_RADIO_D3A1)->GetSafeHwnd(), 0);
		Button_SetCheck(GetDlgItem(IDC_RADIO_D2A2)->GetSafeHwnd(), 0);
		Button_SetCheck(GetDlgItem(IDC_RADIO_D1A3)->GetSafeHwnd(), 0);
		OnBnClickedButtonSetReadMode();										// mode ̐ݒĂ


		OnBnClickedButtonReadId();	// ID ǂł
	}
	else {
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_INITIALIZE)->GetSafeHwnd(), _T("failed"));
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonUninitialize()
{
	// TODO: Add your control notification handler code here
	if (m_usbiomini.Uninitialize()) {
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_UNINITIALIZE)->GetSafeHwnd(), _T("succeeded"));
	}
	else {
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_UNINITIALIZE)->GetSafeHwnd(), _T("failed"));
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonReadVersion()
{
	// TODO: Add your control notification handler code here
	if (m_usbiomini.IsInitialized()) {
		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		pucBuf[1] = UIMC_READ_VERSION;		// command
		m_usbiomini.WriteRAW(pucBuf);		// Write 

		m_usbiomini.ReadRAW(pucBuf);		//  Read ɕԂĂ

		CString str;
		str.Format(_T("%d"), pucBuf[2]);
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_VERSION)->GetSafeHwnd(), str);

		delete [] pucBuf;
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonReadId()
{
	// TODO: Add your control notification handler code here

	if (m_usbiomini.IsInitialized()) {
		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		pucBuf[1] = UIMC_READ_DEVICE_ID;	// command
		m_usbiomini.WriteRAW(pucBuf);		// Write 

		m_usbiomini.ReadRAW(pucBuf);		//  Read ɕԂĂ

		// m_nDeviceID = pucBuf[2];
		// UpdateData(FALSE);

		CString str;
		str.Format(_T("%d"), pucBuf[2]);
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ID)->GetSafeHwnd(), str);

		delete [] pucBuf;
	}

}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonWriteId()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (m_usbiomini.IsInitialized()) {
		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		pucBuf[1] = UIMC_WRITE_DEVICE_ID;	// command
		pucBuf[2] = m_nDeviceID;			// data
		m_usbiomini.WriteRAW(pucBuf);

		delete [] pucBuf;
	}

}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonSetReadMode()
{
	// TODO: Add your control notification handler code here
	if (m_usbiomini.IsInitialized()) {
		unsigned char ucMode;
		if (Button_GetCheck(GetDlgItem(IDC_RADIO_D4A0)->GetSafeHwnd())) {
			ucMode = UIMC_SET_READ_MODE_D4A0;
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), SW_SHOW);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), SW_SHOW);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), SW_SHOW);
		}
		else if (Button_GetCheck(GetDlgItem(IDC_RADIO_D3A1)->GetSafeHwnd())) {
			ucMode = UIMC_SET_READ_MODE_D3A1;
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), SW_SHOW);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), SW_SHOW);
		}
		else if (Button_GetCheck(GetDlgItem(IDC_RADIO_D2A2)->GetSafeHwnd())) {
			ucMode = UIMC_SET_READ_MODE_D2A2;
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), SW_SHOW);
		}
		else if (Button_GetCheck(GetDlgItem(IDC_RADIO_D1A3)->GetSafeHwnd())) {
			ucMode = UIMC_SET_READ_MODE_D1A3;
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), SW_HIDE);
			::ShowWindow(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), SW_HIDE);
		}

		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		pucBuf[1] = ucMode;					// command
		m_usbiomini.WriteRAW(pucBuf);

		delete [] pucBuf;
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonSetDirection()
{
	// TODO: Add your control notification handler code here

	if (m_usbiomini.IsInitialized()) {
		unsigned char ucDirection = (Button_GetCheck(GetDlgItem(IDC_CHECK_DIRECTION_PB5)->GetSafeHwnd()) << 3)
								  | (Button_GetCheck(GetDlgItem(IDC_CHECK_DIRECTION_PB4)->GetSafeHwnd()) << 2)
								  | (Button_GetCheck(GetDlgItem(IDC_CHECK_DIRECTION_PB3)->GetSafeHwnd()) << 1)
								  | (Button_GetCheck(GetDlgItem(IDC_CHECK_DIRECTION_PB0)->GetSafeHwnd()) << 0);
		
		m_usbiomini.SetDirection(ucDirection);
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonWrite()
{
	// TODO: Add your control notification handler code here

	if (m_usbiomini.IsInitialized()) {
		unsigned char ucData = (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB5)->GetSafeHwnd()) << 3)
							 | (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB4)->GetSafeHwnd()) << 2)
							 | (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB3)->GetSafeHwnd()) << 1)
							 | (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB0)->GetSafeHwnd()) << 0);

		m_usbiomini.Write(ucData);
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonRead()
{
	// TODO: Add your control notification handler code here

	if (m_usbiomini.IsInitialized()) {

		// Digital  4bit ǂނȂAȉ̒ʂ Read() œǂ߂
		// unsigned char ucData = m_usbiomini.Read();
		// Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), ucData & 0x08);
		// Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), ucData & 0x04);
		// Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), ucData & 0x02);
		// Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB0)->GetSafeHwnd(), ucData & 0x01);


		// Digital, Analog ꍇ́AReadRAW() œǂޕKv
		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		BOOL bResult = m_usbiomini.ReadRAW(pucBuf);

		// Analog ȒĺA[h(pucBuf[1])ɂĕԂĂ鐔Ⴄ
		switch (pucBuf[1]) {
		case UIMC_SET_READ_MODE_D4A0:
			// Analog 
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC0)->GetSafeHwnd(), _T("---"));
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC2)->GetSafeHwnd(), _T("---"));
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC3)->GetSafeHwnd(), _T("---"));
			break;

		case UIMC_SET_READ_MODE_D3A1:
		{
			int nADC0 = *((WORD *) (&pucBuf[3]));	// = pucBuf[3] + pucBuf[4] * 256;
			CString str;
			str.Format(_T("%d"), nADC0);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC0)->GetSafeHwnd(), str);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC2)->GetSafeHwnd(), _T("---"));
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC3)->GetSafeHwnd(), _T("---"));
		}
			break;

		case UIMC_SET_READ_MODE_D2A2:
		{
			int nADC0 = *((WORD *) (&pucBuf[3]));	// = pucBuf[3] + pucBuf[4] * 256;
			int nADC2 = *((WORD *) (&pucBuf[5]));	// = pucBuf[5] + pucBuf[6] * 256;
			CString str;
			str.Format(_T("%d"), nADC0);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC0)->GetSafeHwnd(), str);
			str.Format(_T("%d"), nADC2);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC2)->GetSafeHwnd(), str);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC3)->GetSafeHwnd(), _T("---"));
		}
			break;

		case UIMC_SET_READ_MODE_D1A3:
		{
			int nADC0 = *((WORD *) (&pucBuf[3]));	// = pucBuf[3] + pucBuf[4] * 256;
			int nADC2 = *((WORD *) (&pucBuf[5]));	// = pucBuf[5] + pucBuf[6] * 256;
			int nADC3 = *((WORD *) (&pucBuf[7]));	// = pucBuf[7] + pucBuf[8] * 256;
			CString str;
			str.Format(_T("%d"), nADC0);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC0)->GetSafeHwnd(), str);
			str.Format(_T("%d"), nADC2);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC2)->GetSafeHwnd(), str);
			str.Format(_T("%d"), nADC3);
			::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_ADC3)->GetSafeHwnd(), str);
		}
			break;


		}

		// Digital ȒĺApucBuf[2] ɕԂĂ
		unsigned char ucData = pucBuf[2];
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), ucData & 0x08);
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), ucData & 0x04);
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), ucData & 0x02);
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB0)->GetSafeHwnd(), ucData & 0x01);

		delete [] pucBuf;
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonWrite1000()
{
	// TODO: Add your control notification handler code here

	if (m_usbiomini.IsInitialized()) {
		unsigned char ucData = (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB5)->GetSafeHwnd()) << 3)
							 | (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB4)->GetSafeHwnd()) << 2)
							 | (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB3)->GetSafeHwnd()) << 1)
							 | (Button_GetCheck(GetDlgItem(IDC_CHECK_WRITE_PB0)->GetSafeHwnd()) << 0);

		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		pucBuf[1] = UIMC_WRITE_DATA;		// command
		pucBuf[2] = ucData;					// data
		//m_usbiomini.WriteRAW(pucBuf);

		BOOL bResult;
		DWORD dwBegin = GetTickCount();
		for (int i = 0; i < 1000; ++i) {
			bResult = m_usbiomini.WriteRAW(pucBuf);
		}
		DWORD dwEnd = GetTickCount();

		CString str;
		str.Format(_T("write time = %d[ms] --> 4bit x %3.1lftimes/sec\n"), dwEnd - dwBegin, 1000 * 1000 / ((double) dwEnd - dwBegin));
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_BENCH_WRITING)->GetSafeHwnd(), str);

		delete [] pucBuf;
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedButtonRead1000()
{
	// TODO: Add your control notification handler code here

	if (m_usbiomini.IsInitialized()) {
		unsigned char *pucBuf = new unsigned char [m_usbiomini.GetFeatureReportByteLength()];
		pucBuf[0] = 0x00;					//  0x00
		// BOOL bResult = m_usbiomini.ReadRAW(pucBuf);

		BOOL bResult;
		DWORD dwBegin = GetTickCount();
		for (int i = 0; i < 1000; ++i) {
			bResult = m_usbiomini.ReadRAW(pucBuf);
		}
		DWORD dwEnd = GetTickCount();

		CString str;
		str.Format(_T("read time = %d[ms] --> 4bit x %3.1lftimes/sec\n"), dwEnd - dwBegin, 1000 * 1000 / ((double) dwEnd - dwBegin));
		::SetWindowText(GetDlgItem(IDC_STATIC_RESULT_BENCH_READING)->GetSafeHwnd(), str);


		// pucBuf[1]  command = 0x00 ԂĂ
		// pucBuf[2]  PB5, PB4, PB3, PB0 ̒lԂĂ

		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB5)->GetSafeHwnd(), pucBuf[2] & 0x08);
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB4)->GetSafeHwnd(), pucBuf[2] & 0x04);
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB3)->GetSafeHwnd(), pucBuf[2] & 0x02);
		Button_SetCheck(GetDlgItem(IDC_CHECK_READ_PB0)->GetSafeHwnd(), pucBuf[2] & 0x01);

		delete [] pucBuf;
	}
}

void CTestSaltUSBIOMiniDlg::OnBnClickedCheckAutoPolling()
{
	// TODO: Add your control notification handler code here
	if (Button_GetCheck(GetDlgItem(IDC_CHECK_AUTO_POLLING)->GetSafeHwnd())) {
		m_uipTimerID = SetTimer(1, 50, NULL);
	}
	else {
		KillTimer(m_uipTimerID);
	}
}

void CTestSaltUSBIOMiniDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	OnBnClickedButtonRead();
	
	
	CDialog::OnTimer(nIDEvent);
}

void CTestSaltUSBIOMiniDlg::WriteSerial1Byte(unsigned char ucData, unsigned char ucInstruction)
{
	m_usbiomini.Write(0x00);
	m_usbiomini.Write(0x04, 0x04);			// Clock

	for (int i = 0; i < 8; ++i) {
		unsigned char ucBit            = (0x80 >> i);
		unsigned char ucBitData        = (ucData        & ucBit) >> (7 - i);
		unsigned char ucBitInstruction = (ucInstruction & ucBit) >> (7 - i);

		m_usbiomini.Write((ucBitInstruction << 1) | (ucBitData));
		m_usbiomini.Write(0x04, 0x04);		// Clock
	}

	m_usbiomini.Write(0x00);
	m_usbiomini.Write(0x04, 0x04);			// Clock

	m_usbiomini.Write(0x00);
	m_usbiomini.Write(0x04, 0x04);			// Clock
	
	m_usbiomini.Write(0x00);				// ŌɃNbN𗎂Ƃ
	
}


// 4pin (GND) --> 4pin (GND)
// 5pin (PB0) --> 5pin (SDI)
// 2pin (PB3) --> 6pin (SII)
// 3pin (PB4) --> 2pin (SCI)
// 1pin (PB5) --> 7pin (SDO)
// 5V         --> 8pin (Vcc)
// 12V        --> 1pin (#RESET)
void CTestSaltUSBIOMiniDlg::OnBnClickedButtonResetFuseBits()
{
	// TODO: Add your control notification handler code here

	m_usbiomini.Write(0x00);
	m_usbiomini.SetDirection(0x0F);
	
	// 12V 
	AfxMessageBox(_T("USB-IO-Mini --> Fuse  Tiny45\n4pin (GND) --> 4pin (GND)\n5pin (PB0) --> 5pin (SDI)\n2pin (PB3) --> 6pin (SII)\n3pin (PB4) --> 2pin (SCI)\n1pin (PB5) --> 7pin (SDO)\n5V         --> 8pin (Vcc)\n12V        --> 1pin (#RESET)\n ƏԂɌqĂ [OK] ĂB"));

	// Spec  5. Release the Prog_enable[2] pin to avoid drive contention on the Prog_enable[2]/SDO pin.
	BOOL bResult = m_usbiomini.SetDirection(0x07);			// SDO ؂藣

	unsigned char ucDataLow[]        = { 0x40, 0x62, 0x00, 0x00 };	// 0x62 = default
	unsigned char ucInstructionLow[] = { 0x4C, 0x2C, 0x64, 0x6C };
	for (int i = 0; i < sizeof(ucDataLow) / sizeof(ucDataLow[0]); ++i) {
		WriteSerial1Byte(ucDataLow[i], ucInstructionLow[i]);
	}
	for (int i = 0; i < 1000; ++i) {	// SDO オ̂҂
		if (m_usbiomini.Read() & 0x08)
			break;
	}
	
	unsigned char ucDataHigh[]        = { 0x40, 0xDF, 0x00, 0x00 };	// 0xdf = default
	unsigned char ucInstructionHigh[] = { 0x4C, 0x2C, 0x74, 0x7C };
	for (int i = 0; i < sizeof(ucDataHigh) / sizeof(ucDataHigh[0]); ++i) {
		WriteSerial1Byte(ucDataHigh[i], ucInstructionHigh[i]);
	}
	for (int i = 0; i < 1000; ++i)	{ // SDO オ̂҂
		if (m_usbiomini.Read() & 0x08)
			break;
	}
}



